clear

# #############################################################################
#	INTRO
# #############################################################################

# ascii text generated using http://www.network-science.de/ascii/ and font big
echo "                                       __  __                   _   "
echo "                                      |  \/  |                 | |  "
echo "             ___ _   _ _ __   ___ _ __| \  / | ___  _   _ _ __ | |_ "
echo "            / __| | | | '_ \ / _ \ '__| |\/| |/ _ \| | | | '_ \| __|"
echo "            \__ \ |_| | |_) |  __/ |  | |  | | (_) | |_| | | | | |_ "
echo "            |___/\__,_| .__/ \___|_|  |_|  |_|\___/ \__,_|_| |_|\__|"
echo "                      | |                                           "
echo "                      |_|                                           "
echo ""
echo "This script uses the cli tool hfs.util to mount damaged drives."
echo "It can only mount partitions using the hfs file system"
echo ""
echo "YOU NEED TO ENTER YOUR PASSWORD DURING THIS SCRIPT"
echo "ADDITIONALLY YOU NEED TO HAVE ADMINISTRATIVE RIGHTS"
echo ""
echo "Written by Florian Bogner"
echo "           Tools At Work 2011"
echo "           fbogner@toolsatwork.com"
echo ""
echo ""
read -p "Press return to start"











# #############################################################################
#	SHOW DRIVES
# #############################################################################
clear
echo "Below you find all the harddrives Mac OS X was able to recognise."
echo "Please identify the partition you want to mount and enter the "
echo "correct IDENTIFIER below."
echo ""
echo "Partitions:"
diskutil list
echo ""
echo "Which partition should i try to mount?"
read PARTITION 










# #############################################################################
#	MOUNTING
# #############################################################################
clear

TMPDIR=`mktemp -q -d "/tmp/superMount.XXXXXX"`
if [ "$?" != "0" ]; then
	echo "Couldn't create temp file"
	exit 1
fi

echo "Trying to mount partition $PARTITION to $TMPDIR . . ."
echo ""
echo "Log:"
echo "#############################################################################"
echo "Please enter your password when needed."
sudo /System/Library/Filesystems/hfs.fs/hfs.util -m $PARTITION "$TMPDIR" removable readonly nosuid nodev
echo "#############################################################################"
echo ""

if [ "$?" != "0" ]; then
	echo "FAILED TO MOUNT PARTITION $PARTITION!"
else
	echo "NO ERROR DETECTED! PLEASE CHECK THE LOG ABOVE."
	echo ""
	echo "BACKUP YOUR DATA AS FAST AS POSSIBLE!"
fi

disktool -r &>/dev/null

echo ""
echo ""
echo "Here are some further tools that might help:"
echo " - DiskWarrior: http://www.alsoft.com/diskwarrior/index.html"
echo " - DataRescue: http://www.prosofteng.com/products/data_rescue.php"
echo ""




# #############################################################################
#	CLOSE
# #############################################################################
read -p "Press return to close this window"
tty=`tty`
closeWindow="tell application \"Terminal\"
				repeat with i from 1 to number of windows
					if (number of (tabs of (item i of windows) whose tty is \"$tty\")) is not 0 then
						close item i of windows
    	       		exit repeat
  			      end if
			    end repeat
			 end tell"

osascript -e "$closeWindow"